<?php

  /* this script generates a private upload directory for any user
     who requests it.  We don't particularly care if someone 
     "maliciously" does this for another user, as the worst outcome
     is the creation of several thousand entries in the parent
     directory that we're making these in */


  $datadir = '/data/anonftp/pub/upload/user/';

  include_once('../wrapper.php');

  $user = clean_form_data(get_or_post('user'), 'username'); 

  if (!($upw = posix_getpwnam("$user"))) {
     echo "<pre>can't find user '$user', not creating this directory</pre>";
     exit;
  }

  if ($upw['uid'] < 1000) {
     echo "<pre>uid &lt; 1000, not creating this directory</pre>";
     exit;
  }

  $pubdir = $datadir . $user;

  system("/usr/bin/sudo -u root /usr/local/sbin/ftpuploaddir $datadir $user",
         $retval);

  if ($retval == 0) {
     echo "<pre>$pubdir exists and has safe permissions</pre>";
  } else {
    echo "<pre>failure to create $pubdir, retval = $retval</pre>";
    exit;
  }
 
?>
