<?php

  /* 
     This script does no more than create a subdirectory in 
     /data/anonftp/pub/users/ , whose name is that of a valid user, 
     which is owned by that user, and whose permissions are 755 .

     We don't care if someone runs this script on another's behalf;
     the worst that can be done with it is to create several thousand
     entries in /data/anonftp/pub/users/
    
  */

  $datadir = '/data/anonftp/pub/user/';

  include_once('../wrapper.php');

  $user = clean_form_data(get_or_post('user'), 'username'); 

  if (!($upw = posix_getpwnam("$user"))) {
     echo "<pre>can't find user '$user', not creating this directory</pre>";
     exit;
  }

  if ($upw['uid'] < 1000) {
     echo "<pre>uid &lt; 1000, not creating this directory</pre>";
     exit;
  }

  $pubdir = $datadir . $user;

  system("/usr/bin/sudo -u root /usr/local/sbin/ftppubdir $datadir $user", 
         $retval);

  if ($retval == 0) {
     echo "<pre>$pubdir exists and has safe permissions</pre>";
  } else {
    echo "<pre>failure to create $pubdir</pre>";
    exit;
  }
 
?>
